#include <iostream>

#include "operand.h"
#include "cpu.h"


int vm::AddOp::operator()(vm::vcpu& cpu)
{
    vm::data d1 = cpu.top(); cpu.pop();
    vm::data d2 = cpu.top(); cpu.pop();

    cpu.push(vm::data(d1.value() + d2.value()));
    return 0;
}

int vm::SubOp::operator()(vm::vcpu& cpu)
{
    vm::data d1 = cpu.top(); cpu.pop();
    vm::data d2 = cpu.top(); cpu.pop();

    cpu.push(vm::data(d2.value() - d1.value()));

    return 0;
}

int vm::MulOp::operator()(vm::vcpu& cpu)
{
    vm::data d1 = cpu.top(); cpu.pop();
    vm::data d2 = cpu.top(); cpu.pop();

    cpu.push(vm::data(d1.value() * d2.value()));

    return 0;
}

int vm::DivOp::operator()(vm::vcpu& cpu)
{
    vm::data d1 = cpu.top(); cpu.pop();
    vm::data d2 = cpu.top(); cpu.pop();

    cpu.push(vm::data(d2.value() / d1.value()));

    return 0;
}

vm::PushOp::PushOp(const vm::data& data) : IOperand(1), data_(new vm::data(data))
{
}

int vm::PushOp::operator()(vm::vcpu& cpu)
{
    cpu.push(*this->data_);
    return 0;
}

int vm::PopOp::operator()(vm::vcpu& cpu)
{
    std::cout << cpu.top().value();
    cpu.pop();
    return 0;
}
