#include "type.h"
#include "data_structure.h"


using namespace utakata::type;
using namespace utakata;


TypeHash::TypeHash(const std::string& hash, unsigned int num) : hash_(0), hash_string_(hash)
{
    makeHash(hash, num);
}


void TypeHash::makeHash(const std::string& hash, unsigned int num)
{
    // 簡単にハッシュを作成する。
    std::string::const_iterator beg = hash.begin(), end = hash.end();
    hash_ += num;

    unsigned char ch = *beg;
    for (; beg != end; ++beg)
    {
        // 各文字毎に簡単なハッシュ値を算出する。
        hash_ += (ch + (!ch ^ num));
        ch = *beg;
    }
}

TypeDescripter::TypeDescripter(const smart_ptr<TypeHash>& type,
                               const smart_ptr<interpreter::DataEntity>& entity) :
    type_(type), entity_(entity)
{}

const TypeHash& TypeDescripter::getType() const
{
    // 実体を返すが、単純に参照を返すのみとする。
    return *type_;
}

smart_ptr<interpreter::DataEntity> TypeDescripter::getEntity()
{
    return entity_;
}


