#ifndef __VM_H__
#define __VM_H__

#include "smart_ptr.h"
#include <vector>

namespace vm {

    class vcpu;
    class IOperand;

    struct COperandRunner {
        COperandRunner(smart_ptr<vcpu> cpu) : cpu_(cpu) {}
        ~COperandRunner() {}
        
        template<class T>
        int operator()(T& p) {
            return (*p)(*cpu_);
        }

    private:

        smart_ptr<vcpu> cpu_;
    };
    
    class UKVirtualMachine
    {
    public:
        UKVirtualMachine();
        virtual ~UKVirtualMachine();

        /**
           オペランドの配列を受け取り、配列に基づいたデータを実行する
        */
        int run(std::vector<smart_ptr<IOperand> >& ops);

    private:

        smart_ptr<vcpu> cpu_;
    };
};

#endif


